package main

import (
	"log"
	"os"
)

func main() {
	// Open file for reading
	file, err := os.Open("files/empty_new.txt")
	if err != nil {
		log.Println(err)
		return
	}
	defer file.Close()
	// Read up to len(b) bytes from the File
	// Zero bytes written means end of file
	// End of file returns error type io.EOF

	byteSlice := make([]byte, 16)
	bytesRead, err := file.Read(byteSlice)
	if err != nil {
		log.Fatalln(err)
	}
	log.Printf("Number of bytes read: %d\n", bytesRead)
	log.Printf("Data read: %s\n", byteSlice)
}
